this.name        = "demo"; 
this.author      = "eric walch"; 
this.copyright   = " 2008 eric walch."; 
this.description = "Empty script structure"; 
this.version     = "0.0"; 

// N.B. Works only with 1.72+. (Before 1.72, "player.ship" was called "player")


// this only runs once at startup before the demoscreen shows up. Will hardly be needed.
this.startUp = function()
{
}

// this runs after loading in a saved game. missionVariables are read in at this point.
this.reset = function()
{
    this.mustPopulate = true
    /* used for adding ships after a first launch.
    This way you don't have to time consuming check every launch if a ship was already there.
    */
}

this.shipWillDockWithStation = function()
{
    if(missionVariables.offering) missionVariables.offering = null;
    /* When using the missionVariables.offering variable in script you need this function to clear the
    variable in case the player launched from within the missionscreen without making choices. By clearing
    this, most scripts that are created acording this layout will automatic do the offer again.
    */
}

this.shipDockedWithStation = function()
{
        // an other eventhandler cauld have launched the ship already.
        if(player.ship.docked) this.missionOffers()
}

this.missionOffers = function()
{
    if (guiScreen == "GUI_SCREEN_MISSION") return; // there will be a "missionScreenEnded" in future to react uppon.
    if (missionVariables.offering || (mission.choice && mission.choice != "")) return;
    if (player.ship.dockedStation.isMainStation)
    {
        //  Your stuff for the main station
        /*
        Starting with 1.71 setting up a missionscreen became much easier. All the standard stuff is handled
        when using the command:
        mission.runMissionScreen("mission_text", "backgroundscreen.png", "choices_text", "ship_role", "music")
        You can transfer 5 variables at once that formerly had to set or cleared each seperately.
        When not needed you can transfer a nill. nill's at the end can be omittet, in between must be used.
        
        When you do an offer you must set a variable to tell an offer is made. It is not save to use the main mission
        variable for this. Use missionVariables.offering for this. At the same time you know an other script is busy
        offering when this variable is set. In case the player launched from within a missionscreen without making an
        offer, the missionVariables.offering should be reset by script. Please do it on docking and not launching.
        That way other oxp's that might need the value get an last change on using its content.
        */
    }
    else if (player.ship.dockedStation.shipDescription == "My Station")
    {
        // Your stuff for a special named station
    }
}

this.choiceEvaluation = function()
{
    if (missionVariables.offering == "MY_OFFER")
    {
         /* It is saver to not use a simple YES, but use a YES_MISSION. This just for the case there is
         a conflict with an other bad written oxp that also has a YES. */
        if(mission.choice == "YES_MISSION")
        {
            // put your code here. 
            missionVariables.offering = null
            mission.choice = null
            /* resetting the mission.choice triggers the "missionChoiceWasReset" handler. 
            therefor this must always happen after other variables are reset to prefent that the script
            tries to run again.  */
        }
        else
        {
            if (mission.choice == "NO_MISSION")
            {
                // put your code here
                missionVariables.offering = null
                mission.choice = null
            } else {missionVariables.offering = null} // one should never get here.
        }
    }
}

this.missionScreenEnded = function()
{
    if(!player.ship.docked) return;
    if(mission.choice) this.choiceEvaluation()
    this.missionOffers()
}

this.missionChoiceWasReset = function()
{
    if(!player.ship.docked) return;
    this.missionOffers()
}

this.setUpShips = function()
{
    // Put here your code that populates the system.
}

this.shipExitedWitchspace = function()
{
    if(system.isInterstellarSpace) return;
    this.setUpShips();
    // Put here your code else than setting ships up.
}

this.playerEnteredNewGalaxy = function()
{
    // This handler will be rarely needed.
}

this.shipLaunchedFromStation = function()
{
   /* The first launch after a restart the system must be populated after a launch.
   The other times it happens after a WitchspaceJump */
   if(this.mustPopulate) {this.setUpShips(); this.mustPopulate = false}
    // put here your other code.
}
