this.name        = "ups_docs"; 
this.author      = "eric walch"; 
this.copyright   = " 2008 eric walch."; 
this.description = "Docs missions of UPS Courier"; 
this.version     = "1.5.0"; 


this.startUp = function()
{
    if (oolite.compareVersion("1.72") > 0)
    {
        // Oolite version is older than 1.72.
        log("script."+this.name, "This UPS-Courier missions does not run under Oolite version " + oolite.versionString + " Parcel missions are disabled.")
        delete this.missionScreenEnded
        delete this.shipExitedWitchspace
        delete this.shipDockedWithStation
        delete this.shipLaunchedFromStation
        delete this.missionChoiceWasReset
        delete this.playerEnteredNewGalaxy
    }
}

this.reset = function()
{
    if(!missionVariables.ups_docs) this.initialise()
	this.choiceWarning = false
    this.offerWarning = false
    this.mark = false
}

this.initialise = function()
{   // setting up all mission variables.
	missionVariables.ups_docs = "NO" 
	missionVariables.ups_dcount = 0 
	missionVariables.ups_planet = 0 
	missionVariables.ups_cplanet = 0 
	missionVariables.ups_difference = 0 
	missionVariables.ups_parcel = "NO" 
	missionVariables.ups_pcount = 0 
	missionVariables.ups_pplanet = 0 
	missionVariables.ups_container = "NO"
	missionVariables.ups_ccount = 0
	missionVariables.ups_c1count = 0
	missionVariables.ups_c2count = 0 
	missionVariables.ups_ecount = 0 
	missionVariables.ups_cplanet = 0
	missionVariables.ups_galcop_punishment = 0
	missionVariables.ups_reputation = 0
	missionVariables.ups_galaxy = galaxyNumber  // not used anymore. Only stored for compatibility with plist script.
// galaxyNumber is GLOBAL and may change to player.galaxyNumber  in future!!!
}


this.shipWillDockWithStation = function()
{
    if(missionVariables.offering) {missionVariables.offering = null; this.offerWarning = true}
    if(mission.choice && mission.choice != "") {mission.choice = null; this.choiceWarning = true}
}

this.shipDockedWithStation = function()
{
        if(player.ship.docked) this.ups_missionOffers()
}

this.longRangeChart = function() // routine used by 4 ups world scripts
{
    if(guiScreen == "GUI_SCREEN_LONG_RANGE_CHART")
    {
        if(this.mark) {mission.unmarkSystem(this.planetShowNumber); this.mark = false}
        else {mission.markSystem(this.planetShowNumber); this.mark = true}
    }
    else
    {
        this.missionChartTimer.stop()
        mission.unmarkSystem(this.planetShowNumber)
        this.mark = true // Keep this selected system.
        missionVariables.offering = null
        mission.choice = null // make offering available again & trigger the "missionChoiceWasReset" event.
        if(player.ship.docked) this.ups_missionOffers()
    }
}

this.guiScreenChanged = function(newScreen)  // routine used by 4 ups world scripts
{
	if (!this.lookLongRangeChartScreen) return
	if(!player.ship.docked) this.lookLongRangeChartScreen = null
	if (guiScreen == "GUI_SCREEN_LONG_RANGE_CHART")
	{
		this.lookLongRangeChartScreen = null
		if(this.missionChartTimer) this.missionChartTimer.start()
		else this.missionChartTimer = new Timer(this, this.longRangeChart, 0.5, 0.5)
	}
	else player.consoleMessage("Go to the long range screen: F6/F6", 10)
}

this.ups_missionOffers = function()
{
    if (guiScreen == "GUI_SCREEN_MISSION") return; // there will be a "missionScreenEnded" in future to react uppon.
    if (missionVariables.offering || (mission.choice && mission.choice != "")) return;
    if(this.choiceWarning) {mission.runMissionScreen("ups_warning", "UPS.png"); this.choiceWarning = false; return};
    if(this.offerWarning) {mission.runMissionScreen("ups_warning3", "UPS.png"); this.offerWarning = false; return};
	if(!missionVariables.ups_docs) this.initialise();
	var docsStatus = missionVariables.ups_docs;
    if (player.ship.dockedStation.isMainStation)
    {
		
        if(docsStatus == "YES")
        {
            if(player.ship.bounty < 3 && System.government == 6 && !mission.choice)
            {
                missionVariables.ups_docs_appearance = expandDescription("[ups_numbers] [ups_condition] [%I]") 
                this.today = new Date()
                if(this.today.getMonth()==11 && this.today.getDate() > 15 && this.today.getDate() < 26)
                    missionVariables.ups_docs_appearance += " Christmas"
                if (missionVariables.ups_dcount == 0){mission.runMissionScreen("ups_docs_1st_offer", "UPS.png", "ups_docs_accepted_yesno")}
                else {mission.runMissionScreen("ups_docs_offer", "UPS.png", "ups_docs_accepted_yesno")}
                missionVariables.offering = "UPS_DOCS"
            }
        }
        if(docsStatus == "SMALL_DELIVERY" && System.government == 6)
        {
            if(missionVariables.ups_dplanet ==  System.ID)
            {
                missionVariables.ups_docs = "ACCEPTED"
                mission.runMissionScreen("ups_back_at_home", "UPS.png")
                this.increaseReputation(-1)
            }
            else
            {
                missionVariables.ups_docs = "NOT_NOW"
                player.credits += 100
                if(missionVariables.ups_dcount == 0)
                {mission.setBackgroundImage("UPS.png");mission.runMissionScreen("ups_docs_1st_unloading", "UPS.png") }
                else{mission.runMissionScreen("ups_docs_unloading")}
                mission.setInstructionsKey()
                missionVariables.ups_dcount++
                missionVariables.ups_docs_appearance = null
                this.increaseReputation(1)
            }
        }
        if(docsStatus == "LOGGING")
        {
            if(System.government == 6 && !mission.choice && missionVariables.ups_dplanet != System.ID && player.contractReputation > 3)
            {
                    mission.runMissionScreen("ups_docs_offer2", "UPS.png", "ups_docs_accepted_yesnolook")
                    missionVariables.offering = "UPS_DOCS2"
            }
        }
        if(docsStatus == "SPECIAL_DELIVERY")
        {
            if(missionVariables.ups_dplanet == System.ID && System.government == 6 && !missionVariables.ups_docbriefing)
            {
                    mission.runMissionScreen("ups_docs_unloading2a", "UPS.png")
                    mission.setInstructionsKey("ups_docs_small3")
                    missionVariables.ups_docbriefing = "YES"
            }
        }
        if(docsStatus == "ASTEROID_OFFER")
        {
            if(System.countShipsWithRole("asteroid") < 15 && !mission.choice)
            {
                    mission.runMissionScreen("ups_docs_asteroid1", "UPS.png", "ups_docs_asteroid_yesno")
                    missionVariables.offering = "UPS_DOCS_ASTEROID"
            }
        }
        if(player.trumbleCount > 0 && !this.trumbleRepellant && docsStatus == "NOT_NOW")
        {
            if(!mission.choice && Math.random() < player.trumbleCount/20 && player.credits > 2000)
            {
                    missionVariables.ups_difference = player.trumbleCount;
					mission.runMissionScreen("ups_trumble_repellant", "trumblebox.png", "ups_trumble_repellant_yesno");
                    missionVariables.offering = "UPS_DOCS_REPELLANT";
					this.trumbleRepellant = true;
					this.trumbleRepelantTimer = clock.days;
            }
        }
        if(this.trumbleRepellant && clock.days > this.trumbleRepelantTimer + 8 && docsStatus == "NOT_NOW")
        {
					mission.runMissionScreen("ups_trumble_repellant_warning", "UPS.png");
					this.trumbleRepellant = false;
        }
    }
    if ((player.ship.dockedStation.name == "Sun Research Station Alpha" || player.ship.dockedStation.name == "Sun Research Station Beta" || player.ship.dockedStation.name == "Sun Research Station Delta" || player.ship.dockedStation.name == "Sun Research Station Omega"))
    {
        if(docsStatus == "SPECIAL_DELIVERY")
        {
            missionVariables.ups_docs = "NOT_NOW", 
            player.credits += 250 
            mission.runMissionScreen("ups_docs_unloading2")
            mission.setInstructionsKey()
            missionVariables.ups_dcount++
            mission.unmarkSystem(missionVariables.ups_dplanet)
            this.increaseReputation(3)
            if(player.ship.dockedStation.name == "Sun Research Station Alpha" && !missionVariables.ups_sun )
            {
                missionVariables.ups_sun = "NOT_NOW"
                missionVariables.ups_sunbase = "YES"
                missionVariables.ups_sunvisits = 0
                missionVariables.ups_splanetname = missionVariables.ups_dplanetname
                missionVariables.ups_splanet = missionVariables.ups_dplanet
            }
            missionVariables.ups_dplanetname = null
            missionVariables.ups_docbriefing = null
        }
    }
}

this.ups_choiceEvaluation = function()
{
    if (missionVariables.offering == "UPS_DOCS")
    {
        if(mission.choice == "YESDoc")
        {
            missionVariables.offering = null
            mission.setInstructionsKey("ups_docs_small") 
            missionVariables.ups_docs = "ACCEPTED" 
            missionVariables.ups_dplanet = System.ID 
            mission.choice = null
        }
        else
        {
            if (mission.choice == "NODoc")
            {
                missionVariables.ups_docs = "NOT_NOW" 
                missionVariables.offering = null
                missionVariables.ups_docs_appearance = null
                mission.choice = null
                this.increaseReputation(-2)
            } else {mission.runMissionScreen("ups_warning2", "UPS.png"); missionVariables.offering = null}
        }
    }
    if (missionVariables.offering == "UPS_DOCS2")
    {
        this.mark = false
        if(mission.choice == "YESDoc")
        {
            mission.setInstructionsKey("ups_docs_small2") 
            missionVariables.ups_docs = "SPECIAL_DELIVERY" 
            missionVariables.offering = null
            mission.choice = null
            mission.markSystem(missionVariables.ups_dplanet) 
        }
        else
        {
            if(mission.choice == "LOOKDoc")
            {
                this.lookLongRangeChartScreen = true
				this.mark = true
				this.planetShowNumber = missionVariables.ups_dplanet
				mission.runMissionScreen("ups_long_range_screen")
				missionVariables.offering = null
            }
            else
            {
                if (mission.choice == "NODoc")
                {
                    missionVariables.ups_docs = "NOT_NOW" 
                    missionVariables.offering = null
                    mission.choice = null
                } else {mission.runMissionScreen("ups_warning2", "UPS.png"); missionVariables.offering = null}
            }
        }
    }
    if (missionVariables.offering == "UPS_DOCS_ASTEROID")
    {
        if(mission.choice == "YESDoc")
        {
            missionVariables.offering == "UPS_DOCS_ASTEROID2"
            mission.runMissionScreen("ups_docs_asteroid2")
            mission.setInstructionsKey("ups_docs_asteroid_short") 
            missionVariables.ups_docs = "ASTEROID"
            missionVariables.ups_asteroid_count = 16
            missionVariables.offering = null
            mission.choice = null
        }
        else
        {
            if (mission.choice == "NODoc")
            {
                missionVariables.ups_docs = "NOT_NOW" 
                missionVariables.offering = null
                mission.choice = null
            } else {mission.runMissionScreen("ups_warning2", "UPS.png"); missionVariables.offering = null}
        }
    }
    if (missionVariables.offering == "UPS_DOCS_REPELLANT")
    {
        if(mission.choice == "YESDoc")
        {
            player.credits -= 2000
			missionVariables.offering = null
            mission.choice = null
        }
        else
        {
            if (mission.choice == "NODoc")
            {
                missionVariables.offering = null
                mission.choice = null
				if(Math.random() < 0.3) this.trumbleRepellant = true;
            } else {mission.runMissionScreen("ups_warning2", "UPS.png"); missionVariables.offering = null}
        }
    }
}

this.missionScreenEnded = function()
{
    if(!player.ship.docked) return;
    if(mission.choice) this.ups_choiceEvaluation()
    this.ups_missionOffers()
}

this.missionChoiceWasReset = function()
{
    if(!player.ship.docked) return;
    this.ups_missionOffers()
}

this.shipExitedWitchspace = function()
{
    if(System.isInterstellarSpace) return;
    this.setUpShips_ups_docs();
    if(missionVariables.ups_docs == "NOT_NOW" && Math.random() < 0.1){missionVariables.ups_docs = "NO"}
    if(missionVariables.ups_docs == "ACCEPTED")
        missionVariables.ups_docs = "SMALL_DELIVERY"; System.legacy_addShipsAt("trader", 2, "pwu", [0, 0, ups_random()])
    if(missionVariables.ups_docs == "NO")
    {
        if(missionVariables.ups_docs == "NO" && Math.random() < 0.2 && System.government == 6)
            missionVariables.ups_docs = "YES"
        if(missionVariables.ups_docs == "NO" && Math.random() < 0.05 && System.government == 6 && missionVariables.ups_dcount > 5 && !System.goneNova)
        {
            missionVariables.ups_docs = "LOGGING"; 
            missionVariables.ups_dplanet = System.ID; 
            missionVariables.ups_dplanetname = expandDescription("[%H]")
        }
        if(missionVariables.ups_docs == "NO" && Math.random() < 0.035 && missionVariables.ups_dcount > 20 && System.countShipsWithRole("asteroid") < 13)
            missionVariables.ups_docs = "ASTEROID_OFFER"
    }
    else
    {
        if (missionVariables.ups_docs == "ASTEROID")
        {
            missionVariables.ups_docs = "NOT_NOW"
            missionVariables.ups_asteroid_count = null
            mission.setInstructionsKey() 
        }
        if (missionVariables.ups_docs == "SMALL_DELIVERY")
        {System.legacy_addSystemShips("trader", 1, Math.random()); System.legacy_addShipsAt("trader", 2, "pwu", [0, 0, ups_random()])}
        if (missionVariables.ups_docs == "SPECIAL_DELIVERY" && System.government < 2)
        {
            System.legacy_addSystemShips("ups_pirate", 10, 1);
            System.legacy_addSystemShips("ups_pirate", 10, 0.15);
            System.legacy_addSystemShips("pirate", 5, Math.random())
            var docpirates1 = System.shipsWithPrimaryRole("ups_pirate");
            for (var i=0; i<docpirates1.length; i++)
                if(docpirates1[i].isValid) //could have already been destroyed
                {
                    if(docpirates1[i].AI == "pirateAI.plist") docpirates1[i].switchAI("upsSecDocPirateAI.plist")
                }
            var docpirates2 = System.shipsWithPrimaryRole("pirate");
            for (var i=0; i<docpirates2.length; i++)
                if(docpirates2[i].isValid) //could have already been destroyed
                {
                    if(docpirates2[i].AI == "pirateAI.plist")
					{
						docpirates2[i].switchAI("upsSecDocPirateAI.plist")
						if(docpirates2[i].bounty == 0) docpirates2[i].bounty = Math.ceil(Math.random()*30)
					}
                }
            System.legacy_addSystemShips("hunter", 3, Math.random())
            if(missionVariables.ups_dcount > 15)
            {
			System.legacy_addShipsAt("ups_pirate_leader", 1, "pwu", [0, 0, 0.35]);
			System.legacy_addSystemShips("ups_pirate_leader", 1, 0.85)
			System.legacy_addShipsAt("ups_pirate_leader", 1, "pwu", [0, 0, 0.75])
			}
        }
    }
}

this.playerEnteredNewGalaxy = function()
{
    // reset missions on galactic jump
    if(missionVariables.ups_docs == "LOGGING" || missionVariables.ups_docs == "SPECIAL_DELIVERY")
    {
        missionVariables.ups_dplanetname = null
        missionVariables.ups_docsbriefing = null
        missionVariables.ups_docs = "NOT_NOW"
        mission.setInstructionsKey()
        mission.unmarkSystem(missionVariables.ups_dplanet)
        missionVariables.ups_dplanet = null
        missionVariables.ups_docs_appearance = null
    }
}

this.setUpShips_ups_docs = function()
{
    if(missionVariables.ups_docs == "SPECIAL_DELIVERY" && missionVariables.ups_dplanet == System.ID)
    {
        var addSunskimmers = false
        if(!missionVariables.ups_sun)
        {
            if(System.countShipsWithRole("ups_dependance") == 0)
            {System.legacy_addShipsAt("ups_dependance", 1, "sps", [0, 0, 2.6]); addSunskimmers = true}
        }
        else
        {
            if(System.countShipsWithRole("ups_dependance2") == 0)
            {System.legacy_addShipsAt("ups_dependance2", 1, "sps", [0, 0, 2.6]); addSunskimmers = true}
        }
        if(addSunskimmers)
        {
            System.legacy_addShipsAt("ups-sunskim", 3, "sps", [0, 0, 2.6])
            System.legacy_addShipsAt("ups_shuttle", 8, "sps", [0, 0, 2.6])
            System.legacy_addShipsAt("ups-sunskim", 1, "spu", [0, 0, ups_random()])
            System.legacy_addShipsAt("ups-sunskim", 1, "spu", [0, 0, ups_random()])
            System.legacy_addShipsAt("ups-sunskim", 1, "spu", [0, 0, ups_random()])
            System.legacy_addShipsAt("ups-sunskim", 1, "spu", [0, 0, ups_random()])
            System.legacy_addShipsAt("ups-sun-police", 4, "spu", [0, 0, ups_random()])
            System.legacy_addShipsAt("ups-sunskim", 1, "swu", [0, 0, ups_random()])
            System.legacy_addShipsAt("ups-sunskim", 1, "swu", [0, 0, ups_random()])
            System.legacy_addShipsAt("ups-sunskim", 1, "swu", [0, 0, ups_random()])
            System.legacy_addShipsAt("ups-sunskim", 1, "swu", [0, 0, ups_random()])
            if(worldScripts.transportSchedule  || worldScripts.transportschedule !== undefined)  // has Transports.OXP installed
            {
                System.legacy_addShipsAt("fueltransport", 1, "spu", [0, 0, ups_random()])
                System.legacy_addShipsAt("fueltransport", 1, "spu", [0, 0, ups_random()])
                System.legacy_addShipsAt("fueltransport", 1, "spu", [0, 0, ups_random()])
            }
        }
    }
}

this.shipLaunchedFromStation = function()
{
    this.setUpShips_ups_docs()
    if(missionVariables.ups_docs == "ASTEROID")
    {
        if(System.countShipsWithRole("ups-miner") == 0 && missionVariables.ups_asteroid_count > 8)
        {
            System.legacy_addShipsAt("ups-asteroid", 15, "pwu", [0, 0, -0.5])
            System.legacy_addShipsAt("ups-asteroid", 15, "pwu", [0, 0, -0.7])
            System.legacy_addShipsAt("miner", 2, "pwu", [0, 0, -0.6])
            System.legacy_addShipsAt("miner", 3, "pwu", [0, 0, -0.8])
            System.legacy_addShipsAt("miner", 3, "pwu", [0, 0, -1.0])
            System.legacy_addShipsAt("ups-miner", 2, "pwu", [0, 0, -0.8])
            System.legacy_addShipsAt("ups-miner", 2, "pwu", [0, 0, -1.0])
            var miners = System.shipsWithPrimaryRole("miner");
            for (var i=0; i<miners.length; i++)
                if(miners[i].isValid && miners[i].position.z > System.mainPlanet.position.z) // behind main planet
                {
                    miners[i].switchAI("route1UpsMinerAI.plist");
                    miners[i].primaryRole = "ups-miner";
                }
        }
    }
}

this.increaseReputation = function(reputation)
{
        if(!missionVariables.ups_reputation) missionVariables.ups_reputation = 0
        missionVariables.ups_reputation += reputation
        if(missionVariables.ups_reputation >=3)
        {
            player.increaseContractReputation()
            missionVariables.ups_reputation -= 3
        }
        if(missionVariables.ups_reputation <= -3)
        {
            player.decreaseContractReputation()
            missionVariables.ups_reputation += 3
        }
}

// global defined function with unique name
function  ups_random() { return Math.random()*0.8 + 0.1}

// Code below is used by ship scripts
this.messageTime = clock.absoluteSeconds // for use of spacing NPC messages by ship scripts.

this.messageAllowed = function()
{
    if((clock.absoluteSeconds - this.messageTime) > 5)
    {
        this.messageTime = clock.absoluteSeconds
		return true;
    }
	else return false;
}