this.name        = "ups_parcel"; 
this.author      = "eric walch"; 
this.copyright   = " 2008 eric walch."; 
this.description = "Parcel missions of UPS Courier"; 
this.version     = "1.5.0"; 


this.startUp = function()
{
    if (oolite.compareVersion("1.72") > 0)
    {
        // Oolite version is older than 1.72.
        log("script."+this.name, "This UPS-Courier missions does not run under Oolite version " + oolite.versionString + " Parcel missions are disabled.")
        delete this.missionScreenEnded
        delete this.shipExitedWitchspace
        delete this.shipDockedWithStation
        delete this.missionChoiceWasReset
        delete this.playerEnteredNewGalaxy
    }
    if(worldScripts.TigersTurf) this.pirates = "tigers"; else this.pirates = "ups_pirate";
    this.mark = false
    this.firstLaunch = true
}

this.reset = function()
{
    this.firstLaunch = true
}

this.shipDockedWithStation = function()
{
    if(player.ship.docked) this.ups_missionOffers()
}

this.ups_missionOffers = function()
{
    if (guiScreen == "GUI_SCREEN_MISSION") return; // there will be a "missionScreenEnded" in future to react uppon.
    if (missionVariables.offering || (mission.choice && mission.choice != "")) return;
	var parcelStatus = missionVariables.ups_parcel // for speed reasons don't test to often against a mission variable.
    if (player.ship.dockedStation.isMainStation)
    {
        if (parcelStatus == "YES")
        {
            if (System.government == 4 && missionVariables.ups_dcount > 2 && player.ship.bounty < 3 && player.contractReputation > 2)
            {
                missionVariables.ups_parcel_appearance = expandDescription("[ups_numbers] [ups_colors] [%I]")
                this.today = new Date()
                if(this.today.getMonth()==11 && this.today.getDate() > 15 && this.today.getDate() < 26)
                    missionVariables.ups_parcel_appearance += " Christmas"
                if (missionVariables.ups_pcount == 0)
                    mission.runMissionScreen("ups_parcel_1st_offer", "UPS.png", "ups_parcel_accepted_yesno")
                else mission.runMissionScreen("ups_parcel_offer", "UPS.png", "ups_parcel_accepted_yesno")
                missionVariables.offering ="UPS_PARCELS"
            }
        }
        if(parcelStatus == "SMALL_DELIVERY")
        {
            if(System.government == 4)
            {
                if(missionVariables.ups_pplanet == System.ID)
                {
                    mission.runMissionScreen("ups_back_at_home", "UPS.png")
                    missionVariables.ups_parcel = "ACCEPTED"
                    worldScripts["ups_docs"].increaseReputation(-1)
                }
                else
                {
                    missionVariables.ups_parcel = "NOT_NOW"
                    player.credits += 150
                    mission.setInstructionsKey()
                    if (missionVariables.ups_pcount == 0) {mission.runMissionScreen("ups_parcel_1st_unloading", "UPS.png")}
                    else
                    {
                        if(missionVariables.ups_ambush == "YES")
                        {
                            mission.runMissionScreen("ups_parcel_ambush", "UPS.png")
                            player.credits += 500
                        }
                        else
                        {
                            mission.runMissionScreen("ups_parcel_unloading")
                        }
                    }
                    missionVariables.ups_pcount++
                    worldScripts["ups_docs"].increaseReputation(1)
                    missionVariables.ups_parcel_appearance = null 
                    missionVariables.ups_ambush = null 
                    missionVariables.ups_pplanetname = null
                }
            }
        }
        if (parcelStatus == "LOGGING")
        {
            if(System.government == 4 && player.credits > 15000 && missionVariables.ups_pplanet != System.ID && (missionVariables.ups_ptimerstart + 8) < clock.days && player.contractReputation > 3)
            {
                if(!this.mark) //has not seen this offer before, aka not used the long range chart option.
                {
                    missionVariables.ups_museumGoods = expandDescription("[ups_museumGoods]")
                    if(!missionVariables.ups_trumbles && missionVariables.trumbles == "TRUMBLE_BOUGHT" && Math.random() < 0.75 && player.trumbleCount == 0)
                    {
                        if(player.ship.hasEquipment("EQ_TRUMBLE")){player.ship.removeEquipment("EQ_TRUMBLE")}
                        missionVariables.ups_museumGoods = expandDescription("[ups_trumbles]")
                        missionVariables.ups_trumbles = "ESCAPED"
                    }
                }
                mission.runMissionScreen("ups_parcel_offer2", "UPS.png", "ups_parcel_accepted_yesnolook")
                missionVariables.offering = "UPS_PARCELS2"
            }
        }
        if (parcelStatus == "SPECIAL_DELIVERY")
        {
            if(System.government == 4 && missionVariables.ups_pplanet == System.ID)
            {
                if(missionVariables.ups_trumbles == "ESCAPED")
                {
                    mission.runMissionScreen("ups_parcel_trumbles", "trumblebox.png")
                    player.credits -= 1000
                    missionVariables.ups_trumbles = "YES"
                }
                else
                {
                    mission.runMissionScreen("ups_parcel_unloading2", "UPS.png")
                }
                player.credits += 15000
                missionVariables.ups_pcount++
                mission.setInstructionsKey()
                missionVariables.ups_parcel = "NOT_NOW"
                missionVariables.ups_pplanetname = null
                missionVariables.ups_museumGoods = null
                missionVariables.ups_escorts = null 
                mission.unmarkSystem(missionVariables.ups_pplanet)
                missionVariables.ups_ptimerstart = null 
                worldScripts["ups_docs"].increaseReputation(3)
            }
        }
        if (parcelStatus == "ASTRO_OFFER" && System.government == 3)
        {
            if(System.countShipsWithRole("astrofactory") > 0)
            {
                mission.runMissionScreen("ups_parcel_astroAttack", "UPS.png", "ups_astro_parcel_accepted_yesno")
                this.addAstroPirates(20)
                missionVariables.offering = "UPS_ASTRO_PARCELS"
            }
            else missionVariables.ups_parcel = "NO"
        }
        if (parcelStatus == "ASTRO_ACCEPTED" && System.countShipsWithRole("astrofactory") == 0)
        {
                if(missionVariables.ups_pplanet == System.ID) mission.runMissionScreen("ups_astro_parcel_destroyed")
                mission.setInstructionsKey() 
                missionVariables.ups_parcel = "NOT_NOW"
                mission.unmarkSystem(missionVariables.ups_pplanet)
                missionVariables.ups_pplanetname = null
                missionVariables.ups_parcel_appearance = null
                worldScripts["ups_docs"].increaseReputation(-2)
        }
        if (parcelStatus == "ASTRO_DELIVERY" && missionVariables.ups_pplanet == System.ID)
        {
                mission.runMissionScreen("ups_astro_parcel_unloading")
                player.credits += 250
                missionVariables.ups_pcount++
                mission.setInstructionsKey() 
                missionVariables.ups_parcel = "NOT_NOW"
                mission.unmarkSystem(missionVariables.ups_pplanet)
                missionVariables.ups_pplanetname = null
                missionVariables.ups_parcel_appearance = null
                worldScripts["ups_docs"].increaseReputation(3)
        }
        if (parcelStatus == "MIDAIR_DELIVERY" && missionVariables.ups_pplanet == System.ID)
        {
                mission.runMissionScreen("ups_parcel_unloading")
                player.credits += 150
                missionVariables.ups_pcount++
                mission.setInstructionsKey() 
                missionVariables.ups_parcel = "NOT_NOW"
                mission.unmarkSystem(missionVariables.ups_pplanet)
                missionVariables.ups_pplanetname = null
                worldScripts["ups_docs"].increaseReputation(1)
        }
		if (System.government > 1 && (parcelStatus == "NO" || missionVariables.ups_parcel == "NOT_NOW"))
		{
			switch (player.contractReputation)
			{
				case 7: missionVariables.ups_difference = "outstanding"; break;
				case 6: missionVariables.ups_difference = "excelent"; break;
				case 5: missionVariables.ups_difference = "dedicated"; break;
				case 4: missionVariables.ups_difference = "very good"; break;
				case 3: missionVariables.ups_difference = "good"; break;
				case 2: missionVariables.ups_difference = "above average"; break;
				case 1: missionVariables.ups_difference = "average"; break;
				case 0: missionVariables.ups_difference = "rooky"; break;
				default: missionVariables.ups_difference = "incompetent"; // for all negative numbers
			}
			mission.setInstructionsKey("ups_parcel_reputation")
		}
    }
    if (parcelStatus == "ASTRO_ACCEPTED" && player.ship.dockedStation.name == "Imperial AstroFactory")
    {
            mission.runMissionScreen("ups_astro_parcel_loading")
            missionVariables.ups_parcel = "ASTRO_DELIVERY"
            mission.setInstructionsKey("ups_astro_parcel_small2") 
            var astroPirates = System.shipsWithRole("pirate", player, 40000) // all pirates in a radius of 40000 m around the player
            for (var i=0; i<astroPirates.length;i++)
                if(astroPirates[i].isValid) //could have already been destroyed or not present
                {
                    astroPirates[i].switchAI("upsAmbushPirateAI.plist")
                }
    }
}

this.ups_choiceEvaluation = function()
{
    if (missionVariables.offering == "UPS_PARCELS")
    {
        if(mission.choice == "YESParcel")
        {
            mission.setInstructionsKey("ups_parcel_small") 
            missionVariables.ups_parcel = "ACCEPTED" 
            missionVariables.ups_pplanet = System.ID 
            missionVariables.ups_pplanetname = expandDescription("[%H]")
            missionVariables.offering = null
            mission.choice = null
            if (Math.random() < 0.2 && missionVariables.ups_pcount > 1) missionVariables.ups_ambush = "POSSIBLE"
        }
        else
        {
            if (mission.choice == "NOParcel")
            {
                missionVariables.ups_parcel = "NOT_NOW" 
                missionVariables.ups_parcel_appearance = null
                missionVariables.offering = null
                mission.choice = null
                worldScripts["ups_docs"].increaseReputation(-2)
            } else {mission.runMissionScreen("ups_warning2", "UPS.png"); missionVariables.offering = null}
        }
    }
    if (missionVariables.offering == "UPS_PARCELS2")
    {
        this.mark = false
        if(mission.choice == "YESParcel")
        {
            mission.setInstructionsKey("ups_parcel_small2") 
            missionVariables.ups_parcel = "SPECIAL_DELIVERY" 
            mission.markSystem(missionVariables.ups_pplanet) 
            player.credits -= 10000
            missionVariables.ups_escorts = 8
            missionVariables.offering = null
            mission.choice = null
        }
        else
        {
            if(mission.choice == "LOOKParcel")
            {
				worldScripts.ups_docs.lookLongRangeChartScreen = true
				worldScripts.ups_docs.planetShowNumber = missionVariables.ups_pplanet
				this.mark = true
				mission.runMissionScreen("ups_long_range_screen")
				missionVariables.offering = null
            }
            else
            {
                if (mission.choice == "NOParcel")
                {
                    missionVariables.ups_parcel = "NOT_NOW" 
                    missionVariables.offering = null
                    mission.choice = null
                    worldScripts["ups_docs"].increaseReputation(-2)
                } else {mission.runMissionScreen("ups_warning2", "UPS.png"); missionVariables.offering = null}
            }
        }
    }
    if (missionVariables.offering == "UPS_ASTRO_PARCELS")
    {
        if(mission.choice == "YESParcel")
        {
            mission.setInstructionsKey("ups_astro_parcel_small") 
            missionVariables.ups_parcel = "ASTRO_ACCEPTED" 
            missionVariables.offering = null
            missionVariables.ups_parcel_appearance = "imperial astrofactory"
            missionVariables.ups_pplanet = System.ID 
            missionVariables.ups_pplanetname = expandDescription("[%H]")
            mission.markSystem(missionVariables.ups_pplanet)
            mission.choice = null
        }
        else
        {
            if (mission.choice == "NOParcel")
            {
                missionVariables.ups_parcel = "NOT_NOW" 
                missionVariables.offering = null
                mission.choice = null
                worldScripts["ups_docs"].increaseReputation(-2)
            } else {mission.runMissionScreen("ups_warning2", "UPS.png"); missionVariables.offering = null}
        }
    }
}

this.missionScreenEnded = function()
{
    if(!player.ship.docked) return;
    if(mission.choice) this.ups_choiceEvaluation()
    this.ups_missionOffers()
}

this.missionChoiceWasReset = function()
{
    if(!player.ship.docked) return;
    this.ups_missionOffers()
}

this.addAstroPirates = function(amount)
{
    System.legacy_addShipsAt("pirate", amount, "wpu", [0, 0, 0.3])
    var astroFactory = System.shipsWithPrimaryRole("astrofactory")[0]
    var astroPirates = System.shipsWithPrimaryRole("pirate", astroFactory)
    for (var i=0; i<amount;i++)
        if(astroPirates[i].isValid)
        {
            astroPirates[i].switchAI("upsAstroPirateAI.plist")
            if(astroPirates[i].bounty == 0) astroPirates[i].bounty = Math.random()*100
        }
}

this.shipLaunchedFromStation = function()
{
    if(this.firstLaunch && missionVariables.ups_parcel == "ASTRO_ACCEPTED" && (System.countShipsWithRole("astrofactory") > 0 ||worldScripts.dictatorship_population !== undefined))
    {
        if(System.countShipsWithRole("astrofactory") == 0 && worldScripts.dictatorship_population !== undefined)
        {
            // do population in case we run first after startup.
            System.lagacy_addShipsAt("astrofactory", 1, "wpu", [0, 0, 0.3])
            System.lagacy_addShipsAt("asteroid", 25, "wpu", [0, 0, 0.3])
            System.lagacy_addShipsAt("imptanker", 2, "wpu", [0, 0, 0.3])
            System.lagacy_addShipsAt("impfreighter", 2, "wpu", [0, 0, 0.4])
        }
        this.addAstroPirates(20)
    }
    this.firstLaunch = false
}

this.shipExitedWitchspace = function()
{
    if(System.isInterstellarSpace) return
    if(missionVariables.ups_parcel == "NOT_NOW" && Math.random() < 0.1){missionVariables.ups_parcel = "NO"}
    if(missionVariables.ups_parcel == "NO")
    {
        if(missionVariables.ups_parcel == "NO" && Math.random() < 0.2 && System.government == 4)
        {missionVariables.ups_parcel = "YES"}
        if(missionVariables.ups_parcel == "NO" && Math.random() < 0.05 && System.government == 4 && player.credits > 15000 && !System.goneNova && missionVariables.ups_pcount > 5)
        {
            missionVariables.ups_parcel = "LOGGING"
            missionVariables.ups_pplanet = System.ID
            missionVariables.ups_pplanetname = expandDescription("[%H]")
            missionVariables.ups_ptimerstart = clock.days
        }
        if(missionVariables.ups_parcel == "NO" && Math.random() < 0.1)
        {
            if(System.government > 3 && System.economy > 3 && missionVariables.ups_tcount > 1 && player.contractReputation > 3)
            System.legacy_addShipsAt("derelict2_ptt", 1, "wpu", [0, 0, ups_random()])
        }
        if(missionVariables.ups_parcel == "NO" && missionVariables.ups_trumbles == "YES")
        {
            player.ship.awardEquipment("EQ_TRUMBLE")
            missionVariables.ups_trumbles = "INFECTED"
        }
        if(missionVariables.ups_parcel == "NO" && Math.random() < 0.2 && worldScripts.dictatorship_population !== undefined && System.government == 3 && System.economy < 3 && missionVariables.ups_pcount > 10)
        {
            missionVariables.ups_parcel = "ASTRO_OFFER"
        }
    }
    else
    {
        if(missionVariables.ups_parcel == "ACCEPTED"){missionVariables.ups_parcel = "SMALL_DELIVERY"}
        if(missionVariables.ups_parcel == "SMALL_DELIVERY" && !System.isInterstellarSpace)
        {
            System.legacy_addSystemShips("ups_pirate", 3, 0.33)
            if(Math.random() < 0.1 && missionVariables.ups_ambush == "POSSIBLE")
            {missionVariables.ups_ambush = "YES";player.consoleMessage("Ambush, you are spotted.", 6)}
        }
        if(missionVariables.ups_ambush == "YES" && Math.random() < 0.5 && !System.isInterstellarSpace)
        {
            System.legacy_addShips(this.pirates, 1)
            System.legacy_addSystemShips(this.pirates, 2, 0.2)
            if(player.score > 1000 && (Math.random()*100 + missionVariables.ups_pcount - 2*System.government) > 70)
            {
                System.legacy_addShips("ups_pirate", 3)
                System.legacy_addShipsAt(this.pirates, 3, "wpu", [0, 0, Math.random()*0.9])
                System.legacy_addSystemShips("ups_pirate_leader", 1, Math.random())
            }
            if(player.score > 2500 && (Math.random()*100 + missionVariables.ups_pcount - 2*System.government) > 70)
            {
                System.legacy_addShips(this.pirates, 3)
                System.legacy_addShipsAt(this.pirates, "wpu", 3, [0, 0, ups_random()])
                System.legacy_addShipsAt("ups_pirate_leader", 1, "wpu", [0, 0, ups_random()])
                if(worldScripts.hardpirates1 !== undefined) 
                {
                    System.legacy_addShips("hardpirates", 1)
                    var hardpirates = System.shipsWithPrimaryRole("hardpirates", player.ship);
                    if(hardpirates && hardpirates[0].isValid) hardpirates[0].switchAI("upsAmbushPirateAI.plist")
                }
            }
            var ambushpirates = System.shipsWithPrimaryRole("pirate", player.ship);
            for (var i=0; i<ambushpirates.length;i++)
                if(ambushpirates[i].isValid) //could have already been destroyed or not present
                {
                    if(ambushpirates[i].AI == "pirateAI.plist")
					{
						ambushpirates[i].switchAI("upsAmbushPirateAI.plist")
						if(ambushpirates[i].bounty == 0) ambushpirates[i].bounty = Math.ceil(Math.random()*30)
					}
                }
        }
        if(missionVariables.ups_parcel == "SPECIAL_DELIVERY")
        {
            if(missionVariables.ups_escorts > 0) System.legacy_addShips("escort_ups", missionVariables.ups_escorts)
            if(Math.random() < 0.5)
            {
                System.legacy_addSystemShips("ups_pirate", 4, 0.05)
                System.legacy_addSystemShips("ups_pirate", 3, 0.075)
                System.legacy_addSystemShips("ups_pirate", 3, 0.10)
                System.legacy_addSystemShips("ups_pirate", 2, 0.125)
                System.legacy_addSystemShips("ups_pirate", 1, 0.15)
                var parcelpirates1 = System.shipsWithPrimaryRole("ups_pirate", player.ship);
                for (var i=0; i<13;i++)
                    if(parcelpirates1[i].isValid) parcelpirates1[i].switchAI("upsParcelPirateAI.plist")
            }
            if(Math.random() < 0.25) 
            {
                System.legacy_addShips(this.pirates, 5)
				var parcelpirates2 = System.shipsWithPrimaryRole(this.pirates, player.ship, 30000);
				for (var i=0; i<5;i++)
							if(parcelpirates2[i].isValid)
							{
							parcelpirates2[i].switchAI("upsParcelPirateAI.plist")
							if(parcelpirates2[i].bounty == 0) parcelpirates2[i].bounty = Math.ceil(Math.random()*30)
							}
            }
            System.legacy_addSystemShips("pirate", 5, Math.random())
            var parcelpirates3 = System.shipsWithPrimaryRole("pirate", player.ship);
            for (var i=0; i<parcelpirates3.length; i++)
                if(parcelpirates3[i].isValid)
				{
					parcelpirates3[i].switchAI("upsParcelPirateAI.plist")
					if(parcelpirates3[i].bounty == 0) parcelpirates3[i].bounty = Math.ceil(Math.random()*30)
				}
        }
    }
    if(missionVariables.ups_parcel == "ASTRO_ACCEPTED")
    {
        mission.setInstructionsKey() 
        missionVariables.ups_parcel = "NOT_NOW"
        mission.unmarkSystem(missionVariables.ups_pplanet)
        missionVariables.ups_pplanetname = null
        missionVariables.ups_parcel_appearance = null
    }
}

this.playerEnteredNewGalaxy = function()
{
    // reset missions on galactic jump
    if(missionVariables.ups_parcel == "LOGGING" || missionVariables.ups_parcel == "SPECIAL_DELIVERY" || missionVariables.ups_parcel == "ASTRO_ACCEPTED" || missionVariables.ups_parcel == "MIDAIR_DELIVERY")
    {
            missionVariables.ups_pplanetname = null
            mission.setInstructionsKey()
            mission.unmarkSystem(missionVariables.ups_pplanet)
            missionVariables.ups_pplanet = null
            missionVariables.ups_parcel = "NOT_NOW" 
            missionVariables.ups_ptimerstart = null
    }
    if(!player.ship.hasEquipment("EQ_TRUMBLE")){missionVariables.ups_trumbles = null}
}